---------------------------- MODULE axi_channel ----------------------------
EXTENDS Sequences

CONSTANT Data,ID


VARIABLES valid,ready,data,id
vars == <<valid,ready,data,id>>

TypeOK == /\ valid \in {0,1}
          /\ ready \in {0,1}
          /\ data \in Data 
          /\ id \in ID

Init == /\ valid = 0
        /\ ready = 0
        /\ data \in Data          
        /\ id \in ID

Stable == /\ <<valid,ready>> = <<1,0>>
          /\ \/ UNCHANGED(<<data,id>>) 
             \/ /\ valid' = 0 
                /\ data' \in Data
                /\ id' \in ID 

Latch == /\ <<valid,ready>> = <<1,1>> 
            /\ data' \in Data
            /\ id' \in ID

Other == /\ <<valid,ready>> = <<0,1>>
         /\ data' \in Data
         /\ id' \in ID

Idle == /\ <<valid,ready>> = <<0,0>>
         /\ data' \in Data
         /\ id' \in ID
        

CorrectValidReady == /\ ready' \in {0,1}
                     /\ valid' \in {0,1} 


 Next == /\ CorrectValidReady
         /\ \/ Stable
            \/ Latch
            \/ Other                                   
            \/ Idle

Spec == Init /\ [][Next]_vars /\ WF_vars(Next)
=============================================================================
\* Modification History
\* Created Sun May 03 23:58:16 IDT 2020 by levbroido
